<template>
    <div>
    
        <v-container>
    
            <v-row justify="center">
                <v-expansion-panels accordion>
                    <v-expansion-panel>
                        <v-expansion-panel-header>
                            filtres
                        </v-expansion-panel-header>
                        <v-expansion-panel-content>
                            <v-card width="100%" dense class="mb-2 d-flex pt-n5 pb-n6" outlined tile>
                                <v-row >
                                    <v-col xs="6 " class="mt-n5 mb-n6">
                                        <v-card-text >
                                            <v-text-field v-model="searchWord" label="Rechercher"></v-text-field>
                                        </v-card-text>
                                    </v-col>
                                    <v-col xs="6" >
                                        <v-switch v-model="certif" dense flat :label="`Certifier`"></v-switch>
                                    </v-col>    
                                </v-row>
                            </v-card>
                    
                            <v-card width="100%" class="mb-2 d-flex" outlined tile>
                    
                                <v-card-text>
                    
                                    <v-row class="mt-n8 mb-n8">
                    
                                        <v-col xs="6">
                    
                                            <v-switch v-model="acheter" flat dense :label="`Acheter`"></v-switch>
                    
                                        </v-col>
                    
                                        <v-col xs="6">
                    
                                            <v-switch v-model="louer" flat dense :label="`Louer`"></v-switch>
                    
                                        </v-col>
                    
                                    </v-row>
                    
                                </v-card-text>
                    
                            </v-card>
                    
                            <v-card width="100%" class="mb-2 d-flex" outlined tile>
                    
                                <v-card-text>
                    
                                    <v-row class="mt-n8 mb-n8">
                    
                                        <v-col xs="6">
                    
                                            <v-switch v-model="particulier" flat dense :label="`Particulier`"></v-switch>
                    
                                        </v-col>
                    
                                        <v-col xs="6">
                    
                                            <v-switch v-model="parc" flat dense :label="`Parc auto`"></v-switch>
                    
                                        </v-col>
                    
                                        <v-col xs="6" :class="screen == 'xs' ? 'mt-n8' :''"> 
                    
                                            <v-switch v-model="serviceLocation" flat dense :label="`Location`"></v-switch>
                    
                                        </v-col>
                    
                                        <v-col xs="6" :class="screen == 'xs' ? 'mt-n8' :''">
                    
                                            <v-switch xs1 v-model="concessionnaire" flat dense :label="`Concessionnaire`"></v-switch>
                                        </v-col>
                    
                                    </v-row>
                    
                                </v-card-text>
                    
                            </v-card>
                    
                            <v-card width="100%" class="mb-2 d-flex" outlined tile>
                    
                                <v-card-text>
                    
                                    <v-row>
                    
                                        <v-col sm="4">
                    
                                            <h4 class="text-center mb-1">marques</h4>
                    
                                            <v-sheet class="mx-auto" elevation="0" outlined>
                    
                                                <v-slide-group v-model="marqueindex" class="pa-1" show-arrows>
                    
                                                    <v-slide-item v-for="marquev in marqueVehicule" :key="marquev._id" v-slot="{ active,toggle }">
                    
                                                        <v-card :color="active ? 'primary' : 'grey lighten-1'" class="ma-2" height="50" width="50" :img="$config.DEFAULT_URL +'marque/'+ marquev.logo" @click="toggle">
                    
                                                            <v-row class="fill-height" align="center" v-if="!active">
                    
                                                                <v-col sm="12" align="center" justify="center">
                    
                                                                    <v-icon color="white" size="24" v-text="'mdi-cog'"></v-icon>
                    
                                                                </v-col>
                    
                                                            </v-row>
                    
                                                            <v-row class="fill-height" align="center" justify="center">
                    
                                                                <v-scale-transition>
                    
                                                                    <v-icon v-if="active" color="white" size="24" v-text="'mdi-close-circle-outline'"></v-icon>
                    
                                                                </v-scale-transition>
                    
                                                            </v-row>
                    
                                                        </v-card>
                    
                    
                    
                                                    </v-slide-item>
                    
                                                </v-slide-group>
                    
                                            </v-sheet>
                    
                                        </v-col>
                    
                                        <v-col sm="4">
                    
                                            <h4 class="text-center mb-1">type</h4>
                    
                                            <v-sheet class="mx-auto"  elevation="0" outlined>
                    
                                                <v-slide-group v-model="typeindex" class="pa-1" show-arrows>
                    
                                                    <v-slide-item v-for="typev in typeVehicule" :key="typev._id" v-slot="{ active, toggle }">
                    
                    
                    
                                                        <v-card :color="active ? 'primary' : 'grey lighten-1'" class="ma-2" height="50" width="50" @click="toggle" :img="$config.DEFAULT_URL +'type-vehicule/'+ typev.image">
                    
                                                            <v-row class="fill-height" align="center" v-if="!active">
                    
                                                                <v-col sm="12" align="center" justify="center">
                    
                                                                    <v-icon color="white" size="24" v-text="'mdi-cog'"></v-icon>
                    
                                                                </v-col>
                    
                                                            </v-row>
                    
                                                            <v-row class="fill-height" align="center" justify="center">
                    
                                                                <v-scale-transition>
                    
                                                                    <v-icon v-if="active" color="white" size="24" v-text="'mdi-close-circle-outline'"></v-icon>
                    
                                                                </v-scale-transition>
                    
                                                            </v-row>
                    
                                                        </v-card>
                    
                                                    </v-slide-item>
                    
                                                </v-slide-group>
                    
                                            </v-sheet>
                    
                                        </v-col>
                    
                                        <v-col xs="4">
                    
                                            <h4 class="text-center mb-1">prix</h4>
                    
                                            <v-range-slider v-model="range" :max="max" :min="min" hide-details class="align-center">
                    
                                                <template v-slot:prepend>
                    
                                                    <v-text-field
                    
                                                        :value="range[0]"
                    
                                                        class="mt-0 pt-0"
                    
                                                        hide-details
                    
                                                        single-line
                    
                                                        type="number"
                    
                                                        style="width: 100px"
                    
                                                        @change="$set(range, 0, $event)"
                    
                                                    ></v-text-field>
                                                </template>
                                                <template v-slot:append>
                                                    <v-text-field :value="range[1]" class="mt-0 pt-0" hide-details single-line type="number" style="width: 100px" @change="$set(range, 1, $event)">
                                                    
                                                    </v-text-field>
                                                </template>
                                            </v-range-slider>
                                        </v-col>

                                        
                                        <v-col xs="3" md="3" align="center" align-self="center">
                    
                                            <v-btn color="error" @click="resetAll">
                    
                                                Annuler
                    
                                            </v-btn>
                    
                                        </v-col>
                                    </v-row>
                                </v-card-text>
                            </v-card>
                        </v-expansion-panel-content>
                    </v-expansion-panel>
                </v-expansion-panels>
            </v-row>
            <v-row>
                <v-col sm="4" xs="12" v-for="vehicule in pagination.data" :key="vehicule._id">
                    <v-card
                    class="mx-auto"
                    color="grey lighten-4"
                    :to="'/vehicules/'+vehicule._id"
                    >
                    <v-img
                        :aspect-ratio="16/9"
                        min-width="500"
                        :src="$config.DEFAULT_URL +'vehicule/'+ vehicule.images[0]"
                    >
                    </v-img>
                    <v-card-text
                        class="pt-6"
                        style="position: relative;"
                    >
                        <v-btn
                        absolute
                        color="primary"
                        class="white--text"
                        fab
                        large
                        right
                        top
                        >
                        <v-icon>mdi-eye</v-icon>
                        </v-btn>
                        <div class="font-weight-light grey--text title mb-2">
                            {{ vehicule.nom }}
                        </div>
                        <h3 class=" font-weight-light primary--text mb-2">
                        
                        </h3>
                    </v-card-text>
                    </v-card>
                </v-col>
            </v-row>
        </v-container>
        <v-container>
            <div class="text-center">
                <v-pagination
                v-model="page"
                :length="pagination.total_pages"
                ></v-pagination>
            </div>
        </v-container>
    </div>
</template>
<script>
export default {
    name: "vehicules",
    data: () => ({
        page: 1,
        particulier: true,
        concessionnaire: true,
        certif:true,
        acheter: true,
        louer: true,
        parc: true,
        serviceLocation: true,
        marqueindex: null,
        typeindex: null,
        marque: null,
        type: null,
        min: 0,
        max: 500000000,
        range: [0, 500000000],
        typeVehicule: [],
        marqueVehicule: [],
        searchWord: "",
        pagination: {}
    }),

    created() {
        this.getTypeVehicule();
        this.getMarqueVehicule();
        this.getVehicule(this.page);
    },

    methods: {

        async getTypeVehicule() {

            await this.$store.dispatch('autoshop/loadTypeVehicules');
            this.typeVehicule = this.$store.getters["autoshop/typeVehicule"];
            console.log(this.typeVehicule);
        },

        async getMarqueVehicule() {
            await this.$store.dispatch('autoshop/loadMarqueVehicules');
            this.marqueVehicule = this.$store.getters["autoshop/marqueVehicule"];

        },

        async getVehicule(page) {

            await this.$store.dispatch('autoshop/loadVehicules');
            let allVehicule = this.$store.getters["autoshop/vehicules"];
           
            allVehicule.sort((a,b)=>{
                return  a.prix-b.prix
            });
            this.pagination = this.$config.paginator(allVehicule.reverse(), page);

        },

        filtrerVoiture() {

            let allVehicule = this.$store.getters["autoshop/vehicules"];

            let resultLocationVente = allVehicule.filter((voiture) => {
                if (!this.louer || !this.acheter) {

                    let isVente = true;
                    if (!this.acheter) {
                        isVente = false;
                    }
                    if (!this.louer) {
                        isVente = true;
                    }

                    if (!this.louer && !this.acheter) {
                        return false;
                    }
                    return voiture.isVente === isVente && voiture.nom.toLowerCase().includes(this.searchWord.toLowerCase());
                }

                return voiture.nom.toLowerCase().includes(this.searchWord.toLowerCase()) && true;
            })

            let resultParticulier = resultLocationVente.filter((voiture) => {


                if (this.particulier) {
                    return voiture.client !== undefined
                }


                return false;

            });


            let resultParcAuto = resultLocationVente.filter((voiture) => {

                if (this.parc) {
                    return voiture.parc_auto !== undefined
                }

                return false;

            });

            let resultConcessionnaire = resultLocationVente.filter((voiture) => {

                if (this.concessionnaire) {
                    return voiture.id_concessionnaire !== undefined;
                }

            });

             let resultCertif= resultLocationVente.filter((voiture) => {

                if (this.certif) {
                    return voiture.isSpecial !== false;
                }

            });


            let resultServiceLocation = resultLocationVente.filter((voiture) => {

                if (this.serviceLocation) {
                    return voiture.service_location !== undefined;
                }

            });


            let resultTypeVehicule = [];
            if (this.type !== null) {

                resultTypeVehicule = resultLocationVente.filter((voiture) => {

                    return voiture.type_vehicule._id === this.type._id

                })

            }

            let dataFlitrer = [];

            dataFlitrer = [...resultParcAuto, ...resultParticulier, ...resultConcessionnaire, ...resultTypeVehicule, ...resultServiceLocation,...resultCertif];
            let uniq = [...new Set(dataFlitrer)];

            let lastResult = uniq.filter((voiture) => {

                console.log("type", this.type);
                console.log("marque", this.marque);


                return ((this.type !== null) ? voiture.type_vehicule._id === this.type._id : true) && ((this.marque !== null) ? voiture.id_marque._id === this.marque._id : true) && voiture.prix >= this.range[0] && voiture.prix <= this.range[1]

            })

            lastResult.sort((voiture1,voiture2)=> voiture1.prix-voiture2.prix );



            this.pagination = this.$config.paginator(lastResult.reverse());


        },

        resetAll() {

            this.particulier = true;
            this.concessionnaire = true;
            this.certif = true;
            this.acheter = true;
            this.louer = true;
            this.parc = true;
            this.marqueindex = null;
            this.typeindex = null;
            this.marque = null;
            this.type = null;
            this.searchWord = "";
            this.range = [0, 500000000];

        }

    },
    computed:{
        screen(){
            return this.$vuetify.breakpoint.name
        },
    },
    watch: {
        page(value) {
            this.getVehicule(value)
        },
        louer() {

            this.filtrerVoiture()
        },
        acheter() {
            this.filtrerVoiture()
        },
        particulier() {
            this.filtrerVoiture()
        },

        parc() {
            this.filtrerVoiture()
        },
        concessionnaire() {
            this.filtrerVoiture();
        },
        certif(){
          this.filtrerVoiture();
        },
        searchWord() {
            this.filtrerVoiture();
        },

        serviceLocation() {
            this.filtrerVoiture();
        },

        marqueindex(value) {



            if (value !== null && value !== undefined) {
                this.marque = this.marqueVehicule[value];
            } else {
                this.marque = null;
            }

        },

        typeindex(value) {




            if (value !== null && value !== undefined) {
                this.type = this.typeVehicule[value];
            } else {
                this.type = null;
            }
        },
        marque() {
            this.filtrerVoiture();
        },
        type() {
            this.filtrerVoiture();
        },
        range() {
            this.filtrerVoiture();

        },

    }
}
</script>>
<style scoped>
.v-card--reveal {
    align-items: center;
    bottom: 0;
    justify-content: center;
    opacity: .5;
    position: absolute;
    width: 100%;
}
</style>
